<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetMagazalar StructType
 * @subpackage Structs
 */
class GetMagazalar extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The Filtre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WebMagazaFiltre
     */
    public $Filtre;
    /**
     * Constructor method for GetMagazalar
     * @uses GetMagazalar::setUyeKodu()
     * @uses GetMagazalar::setFiltre()
     * @param string $uyeKodu
     * @param \StructType\WebMagazaFiltre $filtre
     */
    public function __construct($uyeKodu = null, \StructType\WebMagazaFiltre $filtre = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setFiltre($filtre);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\GetMagazalar
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uyeKodu, true), gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get Filtre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WebMagazaFiltre|null
     */
    public function getFiltre()
    {
        return isset($this->Filtre) ? $this->Filtre : null;
    }
    /**
     * Set Filtre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WebMagazaFiltre $filtre
     * @return \StructType\GetMagazalar
     */
    public function setFiltre(\StructType\WebMagazaFiltre $filtre = null)
    {
        if (is_null($filtre) || (is_array($filtre) && empty($filtre))) {
            unset($this->Filtre);
        } else {
            $this->Filtre = $filtre;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetMagazalar
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
